// Objective-C API for talking to github.com/ethereum/go-ethereum/mobile Go package.
//   gobind -lang=objc -prefix=Go github.com/ethereum/go-ethereum/mobile
//
// File is generated by gobind. Do not edit.

#ifndef __GoGeth_H__
#define __GoGeth_H__

#include <Foundation/Foundation.h>
#include "GoUniverse.h"

@class GoGethAccount;
@class GoGethAccountManager;
@class GoGethAccounts;
@class GoGethAddress;
@class GoGethAddresses;
@class GoGethBigInt;
@class GoGethBigInts;
@class GoGethBlock;
@class GoGethBloom;
@class GoGethBoundContract;
@class GoGethCallMsg;
@class GoGethCallOpts;
@class GoGethChainConfig;
@class GoGethContext;
@class GoGethEnode;
@class GoGethEnodes;
@class GoGethEthereumClient;
@class GoGethFilterQuery;
@class GoGethHash;
@class GoGethHashes;
@class GoGethHeader;
@class GoGethHeaders;
@class GoGethInterface;
@class GoGethInterfaces;
@class GoGethLog;
@class GoGethLogs;
@class GoGethNode;
@class GoGethNodeConfig;
@class GoGethNodeInfo;
@class GoGethNonce;
@class GoGethPeerInfo;
@class GoGethPeerInfos;
@class GoGethReceipt;
@class GoGethStrings;
@class GoGethSubscription;
@class GoGethSyncProgress;
@class GoGethTopics;
@class GoGethTransactOpts;
@class GoGethTransaction;
@class GoGethTransactions;
@protocol GoGethFilterLogsHandler;
@class GoGethFilterLogsHandler;
@protocol GoGethNewHeadHandler;
@class GoGethNewHeadHandler;
@protocol GoGethSigner;
@class GoGethSigner;

@interface GoGethAccount : NSObject {
}
@property(strong, readonly) id _ref;

- (id)initWithRef:(id)ref;
- (GoGethAddress*)getAddress;
- (NSString*)getFile;
@end

@interface GoGethAccountManager : NSObject {
}
@property(strong, readonly) id _ref;

- (id)initWithRef:(id)ref;
- (BOOL)deleteAccount:(GoGethAccount*)a passphrase:(NSString*)passphrase error:(NSError**)error;
- (BOOL)exportKey:(GoGethAccount*)a passphrase:(NSString*)passphrase newPassphrase:(NSString*)newPassphrase ret0_:(NSData**)ret0_ error:(NSError**)error;
- (GoGethAccounts*)getAccounts;
- (BOOL)hasAddress:(GoGethAddress*)addr;
- (BOOL)importKey:(NSData*)keyJSON passphrase:(NSString*)passphrase newPassphrase:(NSString*)newPassphrase ret0_:(GoGethAccount**)ret0_ error:(NSError**)error;
- (BOOL)importPreSaleKey:(NSData*)keyJSON passphrase:(NSString*)passphrase ret0_:(GoGethAccount**)ret0_ error:(NSError**)error;
- (BOOL)lock:(GoGethAddress*)addr error:(NSError**)error;
- (BOOL)newAccount:(NSString*)passphrase ret0_:(GoGethAccount**)ret0_ error:(NSError**)error;
- (BOOL)sign:(GoGethAddress*)addr hash:(NSData*)hash ret0_:(NSData**)ret0_ error:(NSError**)error;
- (BOOL)signWithPassphrase:(GoGethAddress*)addr passphrase:(NSString*)passphrase hash:(NSData*)hash ret0_:(NSData**)ret0_ error:(NSError**)error;
- (BOOL)timedUnlock:(GoGethAccount*)a passphrase:(NSString*)passphrase timeout:(int64_t)timeout error:(NSError**)error;
- (BOOL)unlock:(GoGethAccount*)a passphrase:(NSString*)passphrase error:(NSError**)error;
- (BOOL)update:(GoGethAccount*)a passphrase:(NSString*)passphrase newPassphrase:(NSString*)newPassphrase error:(NSError**)error;
@end

@interface GoGethAccounts : NSObject {
}
@property(strong, readonly) id _ref;

- (id)initWithRef:(id)ref;
- (BOOL)get:(long)index ret0_:(GoGethAccount**)ret0_ error:(NSError**)error;
- (BOOL)set:(long)index account:(GoGethAccount*)account error:(NSError**)error;
- (long)size;
@end

@interface GoGethAddress : NSObject {
}
@property(strong, readonly) id _ref;

- (id)initWithRef:(id)ref;
- (NSData*)getBytes;
- (NSString*)getHex;
- (BOOL)setBytes:(NSData*)address error:(NSError**)error;
- (BOOL)setHex:(NSString*)address error:(NSError**)error;
@end

@interface GoGethAddresses : NSObject {
}
@property(strong, readonly) id _ref;

- (id)initWithRef:(id)ref;
- (BOOL)get:(long)index ret0_:(GoGethAddress**)ret0_ error:(NSError**)error;
- (BOOL)set:(long)index address:(GoGethAddress*)address error:(NSError**)error;
- (long)size;
@end

@interface GoGethBigInt : NSObject {
}
@property(strong, readonly) id _ref;

- (id)initWithRef:(id)ref;
- (NSData*)getBytes;
- (int64_t)getInt64;
- (NSString*)getString:(long)base;
- (void)setBytes:(NSData*)buf;
- (void)setInt64:(int64_t)x;
- (void)setString:(NSString*)x base:(long)base;
- (NSString*)string;
@end

@interface GoGethBigInts : NSObject {
}
@property(strong, readonly) id _ref;

- (id)initWithRef:(id)ref;
- (BOOL)get:(long)index ret0_:(GoGethBigInt**)ret0_ error:(NSError**)error;
- (BOOL)set:(long)index bigint:(GoGethBigInt*)bigint error:(NSError**)error;
- (long)size;
@end

@interface GoGethBlock : NSObject {
}
@property(strong, readonly) id _ref;

- (id)initWithRef:(id)ref;
- (GoGethBloom*)getBloom;
- (GoGethAddress*)getCoinbase;
- (GoGethBigInt*)getDifficulty;
- (NSData*)getExtra;
- (int64_t)getGasLimit;
- (int64_t)getGasUsed;
- (GoGethHash*)getHash;
- (GoGethHash*)getHashNoNonce;
- (GoGethHeader*)getHeader;
- (GoGethHash*)getMixDigest;
- (int64_t)getNonce;
- (int64_t)getNumber;
- (GoGethHash*)getParentHash;
- (GoGethHash*)getReceiptHash;
- (GoGethHash*)getRoot;
- (int64_t)getTime;
- (GoGethTransaction*)getTransaction:(GoGethHash*)hash;
- (GoGethTransactions*)getTransactions;
- (GoGethHash*)getTxHash;
- (GoGethHash*)getUncleHash;
- (GoGethHeaders*)getUncles;
@end

@interface GoGethBloom : NSObject {
}
@property(strong, readonly) id _ref;

- (id)initWithRef:(id)ref;
- (NSData*)getBytes;
- (NSString*)getHex;
@end

@interface GoGethBoundContract : NSObject {
}
@property(strong, readonly) id _ref;

- (id)initWithRef:(id)ref;
- (BOOL)call:(GoGethCallOpts*)opts out:(GoGethInterfaces*)out method:(NSString*)method args:(GoGethInterfaces*)args error:(NSError**)error;
- (GoGethAddress*)getAddress;
- (GoGethTransaction*)getDeployer;
- (BOOL)transact:(GoGethTransactOpts*)opts method:(NSString*)method args:(GoGethInterfaces*)args ret0_:(GoGethTransaction**)ret0_ error:(NSError**)error;
- (BOOL)transfer:(GoGethTransactOpts*)opts ret0_:(GoGethTransaction**)ret0_ error:(NSError**)error;
@end

@interface GoGethCallMsg : NSObject {
}
@property(strong, readonly) id _ref;

- (id)initWithRef:(id)ref;
- (NSData*)getData;
- (GoGethAddress*)getFrom;
- (int64_t)getGas;
- (GoGethBigInt*)getGasPrice;
- (GoGethAddress*)getTo;
- (GoGethBigInt*)getValue;
- (void)setData:(NSData*)data;
- (void)setFrom:(GoGethAddress*)address;
- (void)setGas:(int64_t)gas;
- (void)setGasPrice:(GoGethBigInt*)price;
- (void)setTo:(GoGethAddress*)address;
- (void)setValue:(GoGethBigInt*)value;
@end

@interface GoGethCallOpts : NSObject {
}
@property(strong, readonly) id _ref;

- (id)initWithRef:(id)ref;
- (int64_t)getGasLimit;
- (BOOL)isPending;
- (void)setContext:(GoGethContext*)context;
- (void)setGasLimit:(int64_t)limit;
- (void)setPending:(BOOL)pending;
@end

@interface GoGethChainConfig : NSObject {
}
@property(strong, readonly) id _ref;

- (id)initWithRef:(id)ref;
- (int64_t)homesteadBlock;
- (void)setHomesteadBlock:(int64_t)v;
- (int64_t)daoForkBlock;
- (void)setDAOForkBlock:(int64_t)v;
- (BOOL)daoForkSupport;
- (void)setDAOForkSupport:(BOOL)v;
@end

@interface GoGethContext : NSObject {
}
@property(strong, readonly) id _ref;

- (id)initWithRef:(id)ref;
- (GoGethContext*)withCancel;
- (GoGethContext*)withDeadline:(int64_t)sec nsec:(int64_t)nsec;
- (GoGethContext*)withTimeout:(int64_t)nsec;
@end

@interface GoGethEnode : NSObject {
}
@property(strong, readonly) id _ref;

- (id)initWithRef:(id)ref;
@end

@interface GoGethEnodes : NSObject {
}
@property(strong, readonly) id _ref;

- (id)initWithRef:(id)ref;
- (BOOL)get:(long)index ret0_:(GoGethEnode**)ret0_ error:(NSError**)error;
- (BOOL)set:(long)index enode:(GoGethEnode*)enode error:(NSError**)error;
- (long)size;
@end

@interface GoGethEthereumClient : NSObject {
}
@property(strong, readonly) id _ref;

- (id)initWithRef:(id)ref;
- (BOOL)callContract:(GoGethContext*)ctx msg:(GoGethCallMsg*)msg number:(int64_t)number ret0_:(NSData**)ret0_ error:(NSError**)error;
- (BOOL)estimateGas:(GoGethContext*)ctx msg:(GoGethCallMsg*)msg ret0_:(GoGethBigInt**)ret0_ error:(NSError**)error;
- (BOOL)filterLogs:(GoGethContext*)ctx query:(GoGethFilterQuery*)query ret0_:(GoGethLogs**)ret0_ error:(NSError**)error;
- (BOOL)getBalanceAt:(GoGethContext*)ctx account:(GoGethAddress*)account number:(int64_t)number ret0_:(GoGethBigInt**)ret0_ error:(NSError**)error;
- (BOOL)getBlockByHash:(GoGethContext*)ctx hash:(GoGethHash*)hash ret0_:(GoGethBlock**)ret0_ error:(NSError**)error;
- (BOOL)getBlockByNumber:(GoGethContext*)ctx number:(int64_t)number ret0_:(GoGethBlock**)ret0_ error:(NSError**)error;
- (BOOL)getCodeAt:(GoGethContext*)ctx account:(GoGethAddress*)account number:(int64_t)number ret0_:(NSData**)ret0_ error:(NSError**)error;
- (BOOL)getHeaderByHash:(GoGethContext*)ctx hash:(GoGethHash*)hash ret0_:(GoGethHeader**)ret0_ error:(NSError**)error;
- (BOOL)getHeaderByNumber:(GoGethContext*)ctx number:(int64_t)number ret0_:(GoGethHeader**)ret0_ error:(NSError**)error;
- (BOOL)getNonceAt:(GoGethContext*)ctx account:(GoGethAddress*)account number:(int64_t)number ret0_:(int64_t*)ret0_ error:(NSError**)error;
- (BOOL)getPendingBalanceAt:(GoGethContext*)ctx account:(GoGethAddress*)account ret0_:(GoGethBigInt**)ret0_ error:(NSError**)error;
- (BOOL)getPendingCodeAt:(GoGethContext*)ctx account:(GoGethAddress*)account ret0_:(NSData**)ret0_ error:(NSError**)error;
- (BOOL)getPendingNonceAt:(GoGethContext*)ctx account:(GoGethAddress*)account ret0_:(int64_t*)ret0_ error:(NSError**)error;
- (BOOL)getPendingStorageAt:(GoGethContext*)ctx account:(GoGethAddress*)account key:(GoGethHash*)key ret0_:(NSData**)ret0_ error:(NSError**)error;
- (BOOL)getPendingTransactionCount:(GoGethContext*)ctx ret0_:(long*)ret0_ error:(NSError**)error;
- (BOOL)getStorageAt:(GoGethContext*)ctx account:(GoGethAddress*)account key:(GoGethHash*)key number:(int64_t)number ret0_:(NSData**)ret0_ error:(NSError**)error;
- (BOOL)getTransactionByHash:(GoGethContext*)ctx hash:(GoGethHash*)hash ret0_:(GoGethTransaction**)ret0_ error:(NSError**)error;
- (BOOL)getTransactionCount:(GoGethContext*)ctx hash:(GoGethHash*)hash ret0_:(long*)ret0_ error:(NSError**)error;
- (BOOL)getTransactionInBlock:(GoGethContext*)ctx hash:(GoGethHash*)hash index:(long)index ret0_:(GoGethTransaction**)ret0_ error:(NSError**)error;
- (BOOL)getTransactionReceipt:(GoGethContext*)ctx hash:(GoGethHash*)hash ret0_:(GoGethReceipt**)ret0_ error:(NSError**)error;
- (BOOL)pendingCallContract:(GoGethContext*)ctx msg:(GoGethCallMsg*)msg ret0_:(NSData**)ret0_ error:(NSError**)error;
- (BOOL)sendTransaction:(GoGethContext*)ctx tx:(GoGethTransaction*)tx error:(NSError**)error;
- (BOOL)subscribeFilterLogs:(GoGethContext*)ctx query:(GoGethFilterQuery*)query handler:(id<GoGethFilterLogsHandler>)handler buffer:(long)buffer ret0_:(GoGethSubscription**)ret0_ error:(NSError**)error;
- (BOOL)subscribeNewHead:(GoGethContext*)ctx handler:(id<GoGethNewHeadHandler>)handler buffer:(long)buffer ret0_:(GoGethSubscription**)ret0_ error:(NSError**)error;
- (BOOL)suggestGasPrice:(GoGethContext*)ctx ret0_:(GoGethBigInt**)ret0_ error:(NSError**)error;
- (BOOL)syncProgress:(GoGethContext*)ctx ret0_:(GoGethSyncProgress**)ret0_ error:(NSError**)error;
@end

@interface GoGethFilterQuery : NSObject {
}
@property(strong, readonly) id _ref;

- (id)initWithRef:(id)ref;
- (GoGethAddresses*)getAddresses;
- (GoGethBigInt*)getFromBlock;
- (GoGethBigInt*)getToBlock;
- (GoGethTopics*)getTopics;
@end

@interface GoGethHash : NSObject {
}
@property(strong, readonly) id _ref;

- (id)initWithRef:(id)ref;
- (NSData*)getBytes;
- (NSString*)getHex;
- (BOOL)setBytes:(NSData*)hash error:(NSError**)error;
- (BOOL)setHex:(NSString*)hash error:(NSError**)error;
@end

@interface GoGethHashes : NSObject {
}
@property(strong, readonly) id _ref;

- (id)initWithRef:(id)ref;
- (BOOL)get:(long)index ret0_:(GoGethHash**)ret0_ error:(NSError**)error;
- (long)size;
@end

@interface GoGethHeader : NSObject {
}
@property(strong, readonly) id _ref;

- (id)initWithRef:(id)ref;
- (GoGethBloom*)getBloom;
- (GoGethAddress*)getCoinbase;
- (GoGethBigInt*)getDifficulty;
- (NSData*)getExtra;
- (int64_t)getGasLimit;
- (int64_t)getGasUsed;
- (GoGethHash*)getHash;
- (GoGethHash*)getHashNoNonce;
- (GoGethHash*)getMixDigest;
- (GoGethNonce*)getNonce;
- (int64_t)getNumber;
- (GoGethHash*)getParentHash;
- (GoGethHash*)getReceiptHash;
- (GoGethHash*)getRoot;
- (int64_t)getTime;
- (GoGethHash*)getTxHash;
- (GoGethHash*)getUncleHash;
@end

@interface GoGethHeaders : NSObject {
}
@property(strong, readonly) id _ref;

- (id)initWithRef:(id)ref;
- (BOOL)get:(long)index ret0_:(GoGethHeader**)ret0_ error:(NSError**)error;
- (long)size;
@end

@interface GoGethInterface : NSObject {
}
@property(strong, readonly) id _ref;

- (id)initWithRef:(id)ref;
- (GoGethAddress*)getAddress;
- (GoGethAddresses*)getAddresses;
- (GoGethBigInt*)getBigInt;
- (GoGethBigInts*)getBigInts;
// skipped method Interface.GetBinaries with unsupported parameter or return types

- (NSData*)getBinary;
- (BOOL)getBool;
// skipped method Interface.GetBools with unsupported parameter or return types

- (GoGethHash*)getHash;
- (GoGethHashes*)getHashes;
- (int16_t)getInt16;
- (int32_t)getInt32;
- (int64_t)getInt64;
- (int8_t)getInt8;
- (NSString*)getString;
- (GoGethStrings*)getStrings;
- (GoGethBigInt*)getUint16;
- (GoGethBigInt*)getUint32;
- (GoGethBigInt*)getUint64;
- (GoGethBigInt*)getUint8;
- (void)setAddress:(GoGethAddress*)address;
- (void)setAddresses:(GoGethAddresses*)addrs;
- (void)setBigInt:(GoGethBigInt*)bigint;
- (void)setBigInts:(GoGethBigInts*)bigints;
// skipped method Interface.SetBinaries with unsupported parameter or return types

- (void)setBinary:(NSData*)binary;
- (void)setBool:(BOOL)b;
// skipped method Interface.SetBools with unsupported parameter or return types

- (void)setDefaultAddress;
- (void)setDefaultAddresses;
- (void)setDefaultBigInt;
- (void)setDefaultBigInts;
- (void)setDefaultBinaries;
- (void)setDefaultBinary;
- (void)setDefaultBool;
- (void)setDefaultBools;
- (void)setDefaultHash;
- (void)setDefaultHashes;
- (void)setDefaultInt16;
- (void)setDefaultInt32;
- (void)setDefaultInt64;
- (void)setDefaultInt8;
- (void)setDefaultString;
- (void)setDefaultStrings;
- (void)setDefaultUint16;
- (void)setDefaultUint32;
- (void)setDefaultUint64;
- (void)setDefaultUint8;
- (void)setHash:(GoGethHash*)hash;
- (void)setHashes:(GoGethHashes*)hashes;
- (void)setInt16:(int16_t)n;
- (void)setInt32:(int32_t)n;
- (void)setInt64:(int64_t)n;
- (void)setInt8:(int8_t)n;
- (void)setString:(NSString*)str;
- (void)setStrings:(GoGethStrings*)strs;
- (void)setUint16:(GoGethBigInt*)bigint;
- (void)setUint32:(GoGethBigInt*)bigint;
- (void)setUint64:(GoGethBigInt*)bigint;
- (void)setUint8:(GoGethBigInt*)bigint;
@end

@interface GoGethInterfaces : NSObject {
}
@property(strong, readonly) id _ref;

- (id)initWithRef:(id)ref;
- (BOOL)get:(long)index ret0_:(GoGethInterface**)ret0_ error:(NSError**)error;
- (BOOL)set:(long)index object:(GoGethInterface*)object error:(NSError**)error;
- (long)size;
@end

@interface GoGethLog : NSObject {
}
@property(strong, readonly) id _ref;

- (id)initWithRef:(id)ref;
- (GoGethAddress*)getAddress;
- (GoGethHash*)getBlockHash;
- (int64_t)getBlockNumber;
- (NSData*)getData;
- (long)getIndex;
- (GoGethHashes*)getTopics;
- (GoGethHash*)getTxHash;
- (long)getTxIndex;
@end

@interface GoGethLogs : NSObject {
}
@property(strong, readonly) id _ref;

- (id)initWithRef:(id)ref;
- (BOOL)get:(long)index ret0_:(GoGethLog**)ret0_ error:(NSError**)error;
- (long)size;
@end

@interface GoGethNode : NSObject {
}
@property(strong, readonly) id _ref;

- (id)initWithRef:(id)ref;
- (BOOL)getEthereumClient:(GoGethEthereumClient**)ret0_ error:(NSError**)error;
- (GoGethNodeInfo*)getNodeInfo;
- (GoGethPeerInfos*)getPeersInfo;
- (BOOL)start:(NSError**)error;
- (BOOL)stop:(NSError**)error;
@end

@interface GoGethNodeConfig : NSObject {
}
@property(strong, readonly) id _ref;

- (id)initWithRef:(id)ref;
- (GoGethEnodes*)bootstrapNodes;
- (void)setBootstrapNodes:(GoGethEnodes*)v;
- (long)maxPeers;
- (void)setMaxPeers:(long)v;
- (BOOL)ethereumEnabled;
- (void)setEthereumEnabled:(BOOL)v;
- (long)ethereumNetworkID;
- (void)setEthereumNetworkID:(long)v;
- (GoGethChainConfig*)ethereumChainConfig;
- (void)setEthereumChainConfig:(GoGethChainConfig*)v;
- (NSString*)ethereumGenesis;
- (void)setEthereumGenesis:(NSString*)v;
- (BOOL)ethereumTestnetNonces;
- (void)setEthereumTestnetNonces:(BOOL)v;
- (long)ethereumDatabaseCache;
- (void)setEthereumDatabaseCache:(long)v;
- (BOOL)whisperEnabled;
- (void)setWhisperEnabled:(BOOL)v;
@end

@interface GoGethNodeInfo : NSObject {
}
@property(strong, readonly) id _ref;

- (id)initWithRef:(id)ref;
- (long)getDiscoveryPort;
- (NSString*)getEnode;
- (NSString*)getID;
- (NSString*)getIP;
- (NSString*)getListenerAddress;
- (long)getListenerPort;
- (NSString*)getName;
- (GoGethStrings*)getProtocols;
@end

@interface GoGethNonce : NSObject {
}
@property(strong, readonly) id _ref;

- (id)initWithRef:(id)ref;
- (NSData*)getBytes;
- (NSString*)getHex;
@end

@interface GoGethPeerInfo : NSObject {
}
@property(strong, readonly) id _ref;

- (id)initWithRef:(id)ref;
- (GoGethStrings*)getCaps;
- (NSString*)getID;
- (NSString*)getLocalAddress;
- (NSString*)getName;
- (NSString*)getRemoteAddress;
@end

@interface GoGethPeerInfos : NSObject {
}
@property(strong, readonly) id _ref;

- (id)initWithRef:(id)ref;
- (BOOL)get:(long)index ret0_:(GoGethPeerInfo**)ret0_ error:(NSError**)error;
- (long)size;
@end

@interface GoGethReceipt : NSObject {
}
@property(strong, readonly) id _ref;

- (id)initWithRef:(id)ref;
- (GoGethBloom*)getBloom;
- (GoGethAddress*)getContractAddress;
- (GoGethBigInt*)getCumulativeGasUsed;
- (GoGethBigInt*)getGasUsed;
- (GoGethLogs*)getLogs;
- (NSData*)getPostState;
- (GoGethHash*)getTxHash;
@end

@interface GoGethStrings : NSObject {
}
@property(strong, readonly) id _ref;

- (id)initWithRef:(id)ref;
- (BOOL)get:(long)index ret0_:(NSString**)ret0_ error:(NSError**)error;
- (BOOL)set:(long)index str:(NSString*)str error:(NSError**)error;
- (long)size;
- (NSString*)string;
@end

@interface GoGethSubscription : NSObject {
}
@property(strong, readonly) id _ref;

- (id)initWithRef:(id)ref;
- (void)unsubscribe;
@end

@interface GoGethSyncProgress : NSObject {
}
@property(strong, readonly) id _ref;

- (id)initWithRef:(id)ref;
- (int64_t)getCurrentBlock;
- (int64_t)getHighestBlock;
- (int64_t)getKnownStates;
- (int64_t)getPulledStates;
- (int64_t)getStartingBlock;
@end

@interface GoGethTopics : NSObject {
}
@property(strong, readonly) id _ref;

- (id)initWithRef:(id)ref;
- (BOOL)get:(long)index ret0_:(GoGethHashes**)ret0_ error:(NSError**)error;
- (BOOL)set:(long)index topics:(GoGethHashes*)topics error:(NSError**)error;
- (long)size;
@end

@interface GoGethTransactOpts : NSObject {
}
@property(strong, readonly) id _ref;

- (id)initWithRef:(id)ref;
- (GoGethAddress*)getFrom;
- (int64_t)getGasLimit;
- (GoGethBigInt*)getGasPrice;
- (int64_t)getNonce;
- (GoGethBigInt*)getValue;
- (void)setContext:(GoGethContext*)context;
- (void)setFrom:(GoGethAddress*)from;
- (void)setGasLimit:(int64_t)limit;
- (void)setGasPrice:(GoGethBigInt*)price;
- (void)setNonce:(int64_t)nonce;
- (void)setSigner:(id<GoGethSigner>)s;
- (void)setValue:(GoGethBigInt*)value;
@end

@interface GoGethTransaction : NSObject {
}
@property(strong, readonly) id _ref;

- (id)initWithRef:(id)ref;
- (GoGethBigInt*)getCost;
- (NSData*)getData;
- (BOOL)getFrom:(GoGethAddress**)ret0_ error:(NSError**)error;
- (int64_t)getGas;
- (GoGethBigInt*)getGasPrice;
- (GoGethHash*)getHash;
- (int64_t)getNonce;
- (GoGethHash*)getSigHash;
- (GoGethAddress*)getTo;
- (GoGethBigInt*)getValue;
- (BOOL)withSignature:(NSData*)sig ret0_:(GoGethTransaction**)ret0_ error:(NSError**)error;
@end

@interface GoGethTransactions : NSObject {
}
@property(strong, readonly) id _ref;

- (id)initWithRef:(id)ref;
- (BOOL)get:(long)index ret0_:(GoGethTransaction**)ret0_ error:(NSError**)error;
- (long)size;
@end

@protocol GoGethFilterLogsHandler
- (void)onError:(NSString*)failure;
- (void)onFilterLogs:(GoGethLog*)log;
@end

@protocol GoGethNewHeadHandler
- (void)onError:(NSString*)failure;
- (void)onNewHead:(GoGethHeader*)header;
@end

@protocol GoGethSigner
- (BOOL)sign:(GoGethAddress*)p0 p1:(GoGethTransaction*)p1 ret0_:(GoGethTransaction**)ret0_ error:(NSError**)error;
@end

FOUNDATION_EXPORT const long GoGethLightScryptN;
FOUNDATION_EXPORT const long GoGethLightScryptP;
FOUNDATION_EXPORT const long GoGethStandardScryptN;
FOUNDATION_EXPORT const long GoGethStandardScryptP;

@interface GoGeth : NSObject
+ (GoGethChainConfig*) mainnetChainConfig;
+ (void) setMainnetChainConfig:(GoGethChainConfig*)v;

+ (NSString*) mainnetGenesis;
+ (void) setMainnetGenesis:(NSString*)v;

+ (GoGethChainConfig*) testnetChainConfig;
+ (void) setTestnetChainConfig:(GoGethChainConfig*)v;

+ (NSString*) testnetGenesis;
+ (void) setTestnetGenesis:(NSString*)v;

@end

FOUNDATION_EXPORT BOOL GoGethBindContract(GoGethAddress* address, NSString* abiJSON, GoGethEthereumClient* client, GoGethBoundContract** ret0_, NSError** error);

FOUNDATION_EXPORT BOOL GoGethDeployContract(GoGethTransactOpts* opts, NSString* abiJSON, NSData* bytecode, GoGethEthereumClient* client, GoGethInterfaces* args, GoGethBoundContract** ret0_, NSError** error);

FOUNDATION_EXPORT GoGethEnodes* GoGethMainnetBootnodes();

FOUNDATION_EXPORT GoGethAccountManager* GoGethNewAccountManager(NSString* keydir, long scryptN, long scryptP);

FOUNDATION_EXPORT BOOL GoGethNewAddressFromBytes(NSData* address, GoGethAddress** ret0_, NSError** error);

FOUNDATION_EXPORT BOOL GoGethNewAddressFromHex(NSString* address, GoGethAddress** ret0_, NSError** error);

FOUNDATION_EXPORT GoGethBigInt* GoGethNewBigInt(int64_t x);

FOUNDATION_EXPORT GoGethCallMsg* GoGethNewCallMsg();

FOUNDATION_EXPORT GoGethCallOpts* GoGethNewCallOpts();

FOUNDATION_EXPORT GoGethChainConfig* GoGethNewChainConfig();

FOUNDATION_EXPORT GoGethContext* GoGethNewContext();

FOUNDATION_EXPORT BOOL GoGethNewEnode(NSString* rawurl, GoGethEnode** ret0_, NSError** error);

FOUNDATION_EXPORT GoGethEnodes* GoGethNewEnodes(long size);

FOUNDATION_EXPORT BOOL GoGethNewEthereumClient(NSString* rawurl, GoGethEthereumClient** ret0_, NSError** error);

FOUNDATION_EXPORT GoGethFilterQuery* GoGethNewFilterQuery();

FOUNDATION_EXPORT BOOL GoGethNewHashFromBytes(NSData* hash, GoGethHash** ret0_, NSError** error);

FOUNDATION_EXPORT BOOL GoGethNewHashFromHex(NSString* hash, GoGethHash** ret0_, NSError** error);

FOUNDATION_EXPORT GoGethInterface* GoGethNewInterface();

FOUNDATION_EXPORT GoGethInterfaces* GoGethNewInterfaces(long size);

FOUNDATION_EXPORT BOOL GoGethNewNode(NSString* datadir, GoGethNodeConfig* config, GoGethNode** ret0_, NSError** error);

FOUNDATION_EXPORT GoGethNodeConfig* GoGethNewNodeConfig();

FOUNDATION_EXPORT GoGethEnodes* GoGethTestnetBootnodes();

@class GoGethFilterLogsHandler;

@class GoGethNewHeadHandler;

@class GoGethSigner;

@interface GoGethFilterLogsHandler : NSObject <GoGethFilterLogsHandler> {
}
@property(strong, readonly) id _ref;

- (id)initWithRef:(id)ref;
- (void)onError:(NSString*)failure;
- (void)onFilterLogs:(GoGethLog*)log;
@end

@interface GoGethNewHeadHandler : NSObject <GoGethNewHeadHandler> {
}
@property(strong, readonly) id _ref;

- (id)initWithRef:(id)ref;
- (void)onError:(NSString*)failure;
- (void)onNewHead:(GoGethHeader*)header;
@end

@interface GoGethSigner : NSObject <GoGethSigner> {
}
@property(strong, readonly) id _ref;

- (id)initWithRef:(id)ref;
- (BOOL)sign:(GoGethAddress*)p0 p1:(GoGethTransaction*)p1 ret0_:(GoGethTransaction**)ret0_ error:(NSError**)error;
@end

#endif
